unit FPCBTypes;
{$H+}
interface
 const
 	PAD_NONE  =0;   //pas shapes
	PAD_ROUND =1;
	PAD_SQUARE=2;
	PAD_RECT  =3;
	PAD_RRECT =4;
  PAD_OVAL  =5;
  PAD_OCT   =6;


  fp_highlight             =3;
  fp_DRC_error             =4;
  fp_board_outline         =5;
  fp_ratline               =6;
  fp_top_silk              =7;
  fp_bottom_silk           =8;
  fp_top_solder_mask       =9;
  fp_bottom_solder_mask    =10;
  fp_drilled_hole          =11;
  fp_top_copper            =12;
  fp_bot_copper	           =13;
  fp_inner1	               =14;
  fp_inner2	               =15;
  fp_inner3                =16;



 type
      FPpadtype= record
                shape:integer;
                width:integer;     //= HEIGHT
                left:integer;
                right:integer;
                corner_rad:integer;
               end;

       FPpadarray=array[1..3] of FPpadtype;

      padstacktype =
            record
               pin_id:string[7];
               hole_diam: integer;
               x:integer;
               y:integer;
               rot:integer;
               pads:FPpadarray;   // top_pad, inner_pad, bottom_pad
            end;



      stroketype=record
                    width, x1, y1, x2, y2: integer;
                    style :integer ;                 //STRAIGHT, ARC_CW, ARC_CCW
                 end;

      strokesarray= array of stroketype;

      padstackarray  = array of padstacktype;

      footprinttype = record
                        //units:string[3];
                        name:string[255];
                        sel_x, sel_y, sel_w, sel_h:integer;		// selection rectangle
                        ref_size, ref_xi, ref_yi, ref_angle, ref_width:integer;	// ref text
                        num_pins:integer;
                        //num_outline_strokes:integer;	// number of strokes in outline
                        outline_stroke: strokesarray;
                        padstack: padstackarray;
                        /////////////////////////////////////////////////
                  //     Xcenter,Ycenter:real; //center tov eerste pin
                  //     rot1:real;            //rotatie tov pin 1 pick&place

                      end;
(*cpart * CPartList::Add( CShape * shape, CString * ref_des, CString * package,
							int x, int y, int side, int angle, int visible, int glued )*)
      parttype = record
                   refdes,pack,value, shape:string;
                   side:integer;
                   xpos1, ypos1    :integer;  //positie eerste pin
                   rot_f:integer;             //part rotatie FPC file
                   //////////////////////////////////////////////////////////
                   X0,Y0:integer;             //positie centroid
                   rot_pp:integer             //rotatie pick and place machine
                 end;


     segtype=    record
               	  file_layer:integer;				      // copper layer
	          width     :integer;				      // width
                   //zijn 4 parameters worden maar 2 gelezen 1e is index
                 end;

     vertextype= record
	                  x,
                    y,               // coords
                    file_layer,
                     // pad_layer,       // layer of pad if this is first or last vertex
                    force_via_flag,  // force a via even if no layer change
                    via_w,
                    via_hole_w,      // via width and hole width (via_w==0 means no via)
                    tee_ID :integer;  // identifier for t-connection
                 end;

      connecttype = record
         // connect: <index> ,<start_pin>,<end_pin>,<nsegs>,<locked>
                      {index,} start_pin, end_pin, nsegs, locked:integer;
                       segs: array of segtype;
                       verts: array of vertextype;
                    end;

      cornertype = record
                     {corner: 1 45212000 32004000 0 0}
                     {index,}   x, y, last_side_style, end_cont  :integer;
                   end;
      cornerstype = array of  cornertype;

      areatype = record
                    { area: 2 3 13 0 }
                    {index,} ncorners, file_layer, hatch :integer;
                    corners : cornerstype;
                 end;

      pintype = record
                  part_index: integer;
                  ref_str : string;
                  pin_num_str :string;
                end;

      connectarray = array of connecttype;
      area_array   = array of areatype;
      pin_array    = array of pintype;

      nettype = record
                  {....
                    net: "net2" 2 1 0 203200 711200 355600 1
                  ...}
                  net_name:string;		// net name
                  npins         :integer;
                  nconnects     :integer;
                  nareas        :integer;
                  def_width     :integer;
                  def_via_w     :integer;
                  def_via_hole_w:integer;
                  visible       :integer;
                  connects: connectarray;
                  areas:    area_array;
                  pins:     pin_array;
                end;

     footprintsarray = array of footprinttype;
     partsarray = array of parttype;
     netsarray = array of nettype;





implementation

end.
 
